// Obrada dinamikih nizova.
#include <stdio.h>
#include <stdlib.h>
#define MAX_N 500
#define USPEH   0
#define NEUSPEH 1
// Stvaranje dinamikog niza itajui s tastature.
int *citaj_niz() {
  int *a = malloc((MAX_N+1)*sizeof(int));
  if (a == NULL) {
    printf("\n*** Neuspesna dodela memorije ***\a\n\n");
    exit(NEUSPEH);
  }
  int n = 0; _Bool greska = 0;
  while (scanf("%d", a+(++n)) && (greska=n==MAX_N)==0);
  getchar();
  if (greska) { printf("\n*** Predugacak niz podataka ***\a\n\n");
                exit(NEUSPEH);
              }
  *a = n - 1;
  return realloc(a, n*sizeof(int));
}
// Ispisivanje dinamikog niza na ekranu.
void pisi_niz(const int *a) {
  for (int i=1; i<=*a; printf("%d ", a[i++]));
}
// Nalaenje fuzije dva dinamika niza.
int *fuzija_nizova(const int *a, const int *b) {
  int na = *a, nb = *b, nc = *a + *b, ia = 1, ib = 1, ic = 1,
      *c = malloc((nc+1)*sizeof(int));
  if (c == NULL) {
    printf("\n*** Neuspesna dodela memorije ***\a\n\n");
    exit(NEUSPEH);
  }
  *c = nc;
  while (ia <= na && ib <= nb)
    c[ic++] = (a[ia] < b[ib]) ? a[ia++] : b[ib++];
  while (ia <= na) c[ic++] = a[ia++];
  while (ib <= nb) c[ic++] = b[ib++];
  return c;
}
// Glavna funkcija za prikaz rada gornjih funkcija.
int main() {
  char odg[2];
  do {
    putchar('\n');
    printf("Prvi  ulazni niz? "); int *a = citaj_niz();
    printf("Drugi ulazni niz? "); int *b = citaj_niz();
    int *c = fuzija_nizova(a, b);
    printf("Rezultujuci niz:  "); pisi_niz(c); putchar('\n');
    free(a); free(b); free(c);
    printf("\nDalje (d/n)? "); scanf("%1s", odg);
  } while (odg[0] == 'd' || odg[0] == 'D');
  return USPEH;
}
