﻿// Ažuriranje zapisa u datoteci o štedišama.

#include <stdio.h>
#include <stdlib.h>
#include "stedisa.h"

int main() {

  // Otvaranje datoteke o štedišama:
  FILE *stednja;              // - datoteka o štedišama
  if ((stednja = fopen("stedise.dat", "r+b")) == NULL) exit(1);
  unsigned int veldat;        // - broj zapisa u datoteci
  fread(&veldat, sizeof veldat, 1, stednja);

  // Ažuriranje stanja uloga pojedinih štediša:
  while (1) {

    // Čitanje šifre sledećeg štediše za obradu:
    unsigned int sifra;       // - šifra štediše
    printf("\nSifra stedise?     "); scanf("%d", &sifra);
  if (sifra == 0) break;      // - kraj programa
    if (sifra <= veldat) {

      // Čitanje zatečenih podataka o štediši iz datoteke:
      Stedisa stedisa;        // - podaci o jednom štediši
      fseek(stednja,
            (sizeof veldat) + (long) (sifra - 1) * (sizeof stedisa),
            SEEK_SET);
      fread(&stedisa, sizeof stedisa, 1, stednja);
      if (stedisa.ime.prezime[0]) {

        // Prikazivanje zatečenih podataka o štediši:
        printf("Stedisa = %s %s\n", stedisa.ime.prezime,
                                    stedisa.ime.licno_ime);
        printf("Staro stanje= %8.2f\n", stedisa.stanje);

        // Čitanje promene stanja uloga: 
        double promena;       // - promena stanja uloga.
        printf("Promena stanja?    "); scanf("%lf", &promena);
        stedisa.stanje += promena;

        // Upisivanje novog sadržaja zapisa o štediši u datoteku:
        fseek(stednja, - (long) (sizeof stedisa), SEEK_CUR);
        fwrite(&stedisa, sizeof stedisa, 1, stednja);
      } else
        printf("*** Ne postoji stedisa s tom sifrom  ***\a\n");
    } else
      printf("*** Ne postoji stedisa s tom sifrom  ***\a\n");
  }
}
