// Definisanje tipa Tacka.
struct tacka { int x, y; };
typedef struct tacka Tacka;

// Obrazovanje take od zadatih koordinata.
inline Tacka pravi_tacku(int x, int y) {
  Tacka t; t.x = x; t.y = y; return t;
}

// Dohvatanje koordinata take.
inline int uzmi_x(Tacka t) { return t.x; }
inline int uzmi_y(Tacka t) { return t.y; }

// Izraunavanje rastojanja izmeu dve take.
#include <math.h>
double rastojanje(Tacka g, Tacka h) {
  return sqrt(pow(g.x-h.x, 2) + pow(g.y-h.y, 2));
}

// Konstanta za oznaavanje koordinatnog poetka.
const Tacka NULA = {0, 0};

// Nalaenje najblie take koordinatnom poetku u nizu taaka.
const Tacka *najbliza(const Tacka a[], int n) {
  const Tacka *min = a;  double r = rastojanje(a[0],NULA);
  for (int i=1; i<n; i++) {
    double s = rastojanje(a[i], NULA);
    if (s < r) {r = s; min = a + i;}
  }
  return min;
}

// Ureivanje niza taaka po rastojanjima od koordinatnog poetka.
void uredi(Tacka a[], int n) {
  if (n > 1) {
    Tacka *min = (Tacka *)najbliza(a, n);
    Tacka pom = *min; *min = *a; *a = pom;
    uredi(a+1, n-1);
  }
}

// Glavna funkcija za ispitivanje prethodnih funkcija.
#include <stdio.h>
#include <stdlib.h>
#define N 26
int main() {
  Tacka tacke[N];
  for (int i=0; i<N; i++) {
    int k = rand() / (RAND_MAX + 1.) * 100;
    tacke[i] = pravi_tacku(k/10, k%10);
    printf("(%d,%d) ", uzmi_x(tacke[i]), uzmi_y(tacke[i]));
    if (i%10==9 || i==N-1) putchar('\n');
  }
  uredi(tacke, N);
  putchar('\n');
  for (int i=0; i<N; i++) {
    printf("(%d,%d) ", uzmi_x(tacke[i]), uzmi_y(tacke[i]));
    if (i%10==9 || i==N-1) putchar('\n');
  }
}
